'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var dotSpinnerAnimation = (0, _styledComponents.keyframes)(['0%,100%{box-shadow:0em -2.6em 0em 0em #32324b,1.8em -1.8em 0 0em rgba(50,50,75,0.2),2.5em 0em 0 0em rgba(50,50,75,0.2),1.75em 1.75em 0 0em rgba(50,50,75,0.2),0em 2.5em 0 0em rgba(50,50,75,0.2),-1.8em 1.8em 0 0em rgba(50,50,75,0.2),-2.6em 0em 0 0em rgba(50,50,75,0.5),-1.8em -1.8em 0 0em rgba(50,50,75,0.7);}12.5%{box-shadow:0em -2.6em 0em 0em rgba(50,50,75,0.7),1.8em -1.8em 0 0em #32324b,2.5em 0em 0 0em rgba(50,50,75,0.2),1.75em 1.75em 0 0em rgba(50,50,75,0.2),0em 2.5em 0 0em rgba(50,50,75,0.2),-1.8em 1.8em 0 0em rgba(50,50,75,0.2),-2.6em 0em 0 0em rgba(50,50,75,0.2),-1.8em -1.8em 0 0em rgba(50,50,75,0.5);}25%{box-shadow:0em -2.6em 0em 0em rgba(50,50,75,0.5),1.8em -1.8em 0 0em rgba(50,50,75,0.7),2.5em 0em 0 0em #32324b,1.75em 1.75em 0 0em rgba(50,50,75,0.2),0em 2.5em 0 0em rgba(50,50,75,0.2),-1.8em 1.8em 0 0em rgba(50,50,75,0.2),-2.6em 0em 0 0em rgba(50,50,75,0.2),-1.8em -1.8em 0 0em rgba(50,50,75,0.2);}37.5%{box-shadow:0em -2.6em 0em 0em rgba(50,50,75,0.2),1.8em -1.8em 0 0em rgba(50,50,75,0.5),2.5em 0em 0 0em rgba(50,50,75,0.7),1.75em 1.75em 0 0em #32324b,0em 2.5em 0 0em rgba(50,50,75,0.2),-1.8em 1.8em 0 0em rgba(50,50,75,0.2),-2.6em 0em 0 0em rgba(50,50,75,0.2),-1.8em -1.8em 0 0em rgba(50,50,75,0.2);}50%{box-shadow:0em -2.6em 0em 0em rgba(50,50,75,0.2),1.8em -1.8em 0 0em rgba(50,50,75,0.2),2.5em 0em 0 0em rgba(50,50,75,0.5),1.75em 1.75em 0 0em rgba(50,50,75,0.7),0em 2.5em 0 0em #32324b,-1.8em 1.8em 0 0em rgba(50,50,75,0.2),-2.6em 0em 0 0em rgba(50,50,75,0.2),-1.8em -1.8em 0 0em rgba(50,50,75,0.2);}62.5%{box-shadow:0em -2.6em 0em 0em rgba(50,50,75,0.2),1.8em -1.8em 0 0em rgba(50,50,75,0.2),2.5em 0em 0 0em rgba(50,50,75,0.2),1.75em 1.75em 0 0em rgba(50,50,75,0.5),0em 2.5em 0 0em rgba(50,50,75,0.7),-1.8em 1.8em 0 0em #32324b,-2.6em 0em 0 0em rgba(50,50,75,0.2),-1.8em -1.8em 0 0em rgba(50,50,75,0.2);}75%{box-shadow:0em -2.6em 0em 0em rgba(50,50,75,0.2),1.8em -1.8em 0 0em rgba(50,50,75,0.2),2.5em 0em 0 0em rgba(50,50,75,0.2),1.75em 1.75em 0 0em rgba(50,50,75,0.2),0em 2.5em 0 0em rgba(50,50,75,0.5),-1.8em 1.8em 0 0em rgba(50,50,75,0.7),-2.6em 0em 0 0em #32324b,-1.8em -1.8em 0 0em rgba(50,50,75,0.2);}87.5%{box-shadow:0em -2.6em 0em 0em rgba(50,50,75,0.2),1.8em -1.8em 0 0em rgba(50,50,75,0.2),2.5em 0em 0 0em rgba(50,50,75,0.2),1.75em 1.75em 0 0em rgba(50,50,75,0.2),0em 2.5em 0 0em rgba(50,50,75,0.2),-1.8em 1.8em 0 0em rgba(50,50,75,0.5),-2.6em 0em 0 0em rgba(50,50,75,0.7),-1.8em -1.8em 0 0em #32324b;}']);

var DotSpinner = _styledComponents2.default.div.withConfig({
  displayName: 'CircularProgress__DotSpinner'
})(['border-radius:50%;position:relative;text-indent:-9999em;-webkit-animation:', ' 1.1s infinite ease;animation:', ' 1.1s infinite ease;-webkit-transform:translateZ(0);-ms-transform:translateZ(0);transform:translateZ(0);', ''], dotSpinnerAnimation, dotSpinnerAnimation, function (props) {
  return props.scale && '\n    margin: ' + 15 * props.scale + 'px;\n    font-size: ' + 5 * props.scale + 'px;\n    width: ' + 5 * props.scale + 'px;\n    height: ' + 5 * props.scale + 'px;\n  ';
});

var ProgressContainer = _styledComponents2.default.div.withConfig({
  displayName: 'CircularProgress__ProgressContainer'
})(['display:inline-block;']);

var ProgressWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'CircularProgress__ProgressWrapper'
})(['width:', 'px;height:', 'px;', ' ', ''], function (props) {
  return props.size;
}, function (props) {
  return props.size;
}, function (props) {
  return props.inline && '\n    display: inline-block;\n    vertical-align: middle;\n  ';
}, function (props) {
  return props.center && '\n    margin-left: auto;\n    margin-right: auto;\n  ';
});

/**
 * Size is set in px
 * ```javascript
 * import React from 'react';
 * import { CircularProgress } from 'weaveworks-ui-components'
 *
 * React.render(
 *   <div>
 *     <CircularProgress size={35} />
 *     <CircularProgress inline /> Inline
 *     <CircularProgress center />
 *   </div>
 * );
 * ```
 */
var CircularProgress = function CircularProgress(props) {
  return _react2.default.createElement(
    ProgressWrapper,
    props,
    _react2.default.createElement(
      ProgressContainer,
      null,
      _react2.default.createElement(DotSpinner, { scale: props.size / 35 })
    )
  );
};

CircularProgress.propTypes = {
  /** Size of spinner in px */
  size: _propTypes2.default.number,
  /** Whether to display the spinner inline */
  inline: _propTypes2.default.bool,
  /** Whether to center the spinner horizontally */
  center: _propTypes2.default.bool
};

CircularProgress.defaultProps = {
  size: 30,
  inline: false,
  center: false
};

exports.default = CircularProgress;