'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  line-height: ', ';\n  color: ', ';\n  min-height: ', ';\n\n  &:hover {\n    background-color: #eee;\n  }\n'], ['\n  line-height: ', ';\n  color: ', ';\n  min-height: ', ';\n\n  &:hover {\n    background-color: #eee;\n  }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  border-radius: ', ';\n  background-color: ', ';\n  border: 1px solid ', ';\n  display: flex;\n\n  ', ' {\n    padding: 0;\n  }\n\n  div:last-child {\n    margin-left: auto;\n  }\n'], ['\n  border-radius: ', ';\n  background-color: ', ';\n  border: 1px solid ', ';\n  display: flex;\n\n  ', ' {\n    padding: 0;\n  }\n\n  div:last-child {\n    margin-left: auto;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var WIDTH = '256px';
var HEIGHT = '36px';

var Item = _styledComponents2.default.div.withConfig({
  displayName: 'Dropdown__Item'
})(['overflow:hidden;text-overflow:ellipsis;white-space:nowrap;padding:0 12px;cursor:pointer;']);

var Popover = _styledComponents2.default.div.withConfig({
  displayName: 'Dropdown__Popover'
})(['position:absolute;background-color:', ';border:1px solid ', ';border-radius:', ';z-index:3;box-shadow:', ';margin-top:4px;width:', ';box-sizing:border-box;'], function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.neutral.lightgray;
}, function (props) {
  return props.theme.borderRadius;
}, function (props) {
  return props.theme.boxShadow.light;
}, WIDTH);

var Overlay = _styledComponents2.default.div.withConfig({
  displayName: 'Dropdown__Overlay'
})(['position:fixed;top:0;bottom:0;right:0;left:0;z-index:2;']);

var ItemWrapper = Item.extend(_templateObject, HEIGHT, function (props) {
  return props.selected ? props.theme.colors.accent.blue : props.theme.textColor;
}, HEIGHT);

var SelectedItem = Item.extend(_templateObject2, function (props) {
  return props.theme.borderRadius;
}, function (props) {
  return props.theme.colors.neutral.white;
}, function (props) {
  return props.theme.colors.neutral.gray;
}, Item);

var SelectedItemIcon = _styledComponents2.default.span.withConfig({
  displayName: 'Dropdown__SelectedItemIcon'
})(['padding-left:1em;float:right;line-height:', ' !important;'], HEIGHT);

var StyledDropdown = function StyledDropdown(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: 'Dropdown'
  })(['height:', ';line-height:', ';position:relative;padding:8px;width:', ';'], HEIGHT, HEIGHT, WIDTH);
};

/**
 * A selectable drop-down menu.
 * ```javascript
 *const items = [
 *  {
 *    value: 'first-thing',
 *    label: 'First Thing',
 *  },
 *  {
 *    value: 'second-thing',
 *    label: 'Second Thing',
 *  },
 *  {
 *    value: 'third-thing',
 *    label: 'Super long thing, this get truncated',
 *  },
 * ];
 *
 * <Dropdown items={items} />
 * ```
 */

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props, context) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props, context));

    _this.state = {
      isOpen: false
    };

    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    _this.handleBgClick = _this.handleBgClick.bind(_this);
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'handleChange',
    value: function handleChange(ev, value) {
      this.setState({ isOpen: false });
      if (this.props.onChange) {
        this.props.onChange(ev, value);
      }
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      this.setState({ isOpen: true });
    }
  }, {
    key: 'handleBgClick',
    value: function handleBgClick() {
      this.setState({ isOpen: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          items = _props.items,
          value = _props.value,
          className = _props.className;
      var isOpen = this.state.isOpen;

      var currentItem = (0, _lodash.find)(items, function (i) {
        return i.value === value;
      }) || items && items[0];

      return _react2.default.createElement(
        'div',
        { className: className, title: currentItem && currentItem.label },
        _react2.default.createElement(
          SelectedItem,
          { onClick: this.handleClick },
          _react2.default.createElement(
            Item,
            null,
            currentItem && currentItem.label
          ),
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(SelectedItemIcon, { className: 'fa fa-caret-down' })
          )
        ),
        isOpen && _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            Popover,
            null,
            (0, _lodash.map)(this.props.items, function (i) {
              return _react2.default.createElement(
                ItemWrapper,
                {
                  className: 'dropdown-item',
                  key: i.value,
                  onClick: function onClick(ev) {
                    return _this2.handleChange(ev, i.value);
                  },
                  selected: i.value === value,
                  title: i.label
                },
                i.label
              );
            })
          ),
          _react2.default.createElement(Overlay, { onClick: this.handleBgClick })
        )
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  /**
   * Array of items that will be selectable. `value` should be an internal value,
   * `label` is what will be displayed to the user.
   */
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    label: _propTypes2.default.string
  })).isRequired,
  /**
   * The value of the currently selected item. This much match a value in the `items` prop.
   * If no value is provided, the first elements's value will be used.
   */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  /**
   * A handler function that will run when a value is selected.
   */
  onChange: _propTypes2.default.func
};

exports.default = StyledDropdown(Dropdown);