'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A child of the `<Grid />` component. Used for building layouts.
 *
 * See also [Grid](/components/Grid)
 */
var GridColumn = function GridColumn(_ref) {
  var children = _ref.children,
      span = _ref.span;
  return _react2.default.createElement(
    'div',
    { className: 'weave-grid-column col-span-' + span },
    children
  );
};

GridColumn.propTypes = {
  /**
   * The desired col-span; maximum of 12 columns
   */
  span: _propTypes2.default.number
};

exports.default = GridColumn;