'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
* A row element that will flex children and align them to the left, center or right.
*/
var GridRow = function GridRow(_ref) {
  var alignContent = _ref.alignContent,
      children = _ref.children;

  var cl = (0, _classnames3.default)('weave-grid-row', _defineProperty({}, 'align-' + alignContent, alignContent));
  return _react2.default.createElement(
    'div',
    { className: cl },
    children
  );
};

GridRow.propTypes = {
  /**
   * The direction in which to justify content. Should be 'left', 'center', or 'right';
  */
  alignContent: _propTypes2.default.string
};

exports.default = GridRow;