'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LegendContainer = _styledComponents2.default.div.withConfig({
  displayName: '_Legend__LegendContainer'
})(['']);

var LegendItems = _styledComponents2.default.div.withConfig({
  displayName: '_Legend__LegendItems'
})(['color:', ';box-sizing:border-box;display:flex;flex-wrap:wrap;position:relative;padding:10px 0;width:100%;'], function (props) {
  return props.theme.colors.neutral.black;
});

var LegendItem = _styledComponents2.default.div.withConfig({
  displayName: '_Legend__LegendItem'
})(['cursor:pointer;display:flex;font-size:13px;align-items:center;padding:3px 17px 3px 8px;border-radius:4px;max-width:45%;&:hover{background-color:', ';}', ';'], function (props) {
  return props.theme.colors.athens;
}, function (props) {
  return props.selected && '\n    background-color: ' + props.theme.colors.athens + ';\n  ';
});

var LegendItemName = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__LegendItemName'
})(['white-space:nowrap;text-overflow:ellipsis;overflow:hidden;']);

var LegendToggle = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__LegendToggle'
})(['color:', ';cursor:pointer;display:block;padding:5px;font-size:15px;width:fit-content;'], function (props) {
  return props.theme.colors.lavender;
});

var LegendCaret = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__LegendCaret'
})(['margin-left:5px;']);

var ColorBox = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__ColorBox'
})(['background-color:', ';border-radius:1px;margin-right:4px;min-width:13px;height:5px;'], function (props) {
  return props.color;
});

var Legend = function (_React$PureComponent) {
  _inherits(Legend, _React$PureComponent);

  function Legend(props, context) {
    _classCallCheck(this, Legend);

    var _this = _possibleConstructorReturn(this, (Legend.__proto__ || Object.getPrototypeOf(Legend)).call(this, props, context));

    _this.handleLegendItemClick = function (series) {
      if (_this.state.selectedLegendSeriesKey === series.key) {
        _this.setState({ selectedLegendSeriesKey: null });
        _this.props.onSelectedLegendSeriesChange(null);
      } else {
        _this.setState({ selectedLegendSeriesKey: series.key });
        _this.props.onSelectedLegendSeriesChange(series.key);
      }
    };

    _this.handleLegendItemMouseEnter = function (series) {
      _this.setState({ hoveredLegendSeriesKey: series.key });
      _this.props.onHoveredLegendSeriesChange(series.key);
    };

    _this.handleLegendItemMouseLeave = function () {
      _this.setState({ hoveredLegendSeriesKey: null });
      _this.props.onHoveredLegendSeriesChange(null);
    };

    _this.handleLegendToggle = function () {
      _this.setState({ legendShown: !_this.state.legendShown });
    };

    _this.state = {
      legendShown: props.legendShown,
      selectedLegendSeriesKey: null,
      hoveredLegendSeriesKey: null,
      multiSeries: []
    };
    return _this;
  }

  _createClass(Legend, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var caretIcon = this.state.legendShown ? 'fa-caret-down' : 'fa-caret-right';

      return _react2.default.createElement(
        LegendContainer,
        null,
        this.props.legendCollapsable && _react2.default.createElement(
          LegendToggle,
          { onClick: this.handleLegendToggle },
          'Legend ',
          _react2.default.createElement(LegendCaret, { className: 'fa ' + caretIcon })
        ),
        this.state.legendShown && _react2.default.createElement(
          LegendItems,
          null,
          this.props.multiSeries.map(function (series) {
            return _react2.default.createElement(
              LegendItem,
              {
                key: series.key,
                title: series.name,
                onClick: function onClick() {
                  return _this2.handleLegendItemClick(series);
                },
                onMouseEnter: function onMouseEnter() {
                  return _this2.handleLegendItemMouseEnter(series);
                },
                onMouseLeave: function onMouseLeave() {
                  return _this2.handleLegendItemMouseLeave();
                },
                selected: _this2.state.selectedLegendSeriesKey === series.key
              },
              _react2.default.createElement(ColorBox, { color: series.color }),
              _react2.default.createElement(
                LegendItemName,
                null,
                series.name
              )
            );
          })
        )
      );
    }
  }]);

  return Legend;
}(_react2.default.PureComponent);

Legend.propTypes = {
  multiSeries: _propTypes2.default.array.isRequired,
  onSelectedLegendSeriesChange: _propTypes2.default.func.isRequired,
  onHoveredLegendSeriesChange: _propTypes2.default.func.isRequired,
  legendCollapsable: _propTypes2.default.bool.isRequired,
  legendShown: _propTypes2.default.bool.isRequired
};

Legend.defaultProps = {
  multiSeries: [],
  legendCollapsable: false,
  legendShown: true
};

exports.default = Legend;