'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.nowInSecondsPrecision = nowInSecondsPrecision;
exports.clampToNowInSecondsPrecision = clampToNowInSecondsPrecision;
exports.scaleDuration = scaleDuration;

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function nowInSecondsPrecision() {
  return (0, _moment2.default)().startOf('second');
}

function clampToNowInSecondsPrecision(timestamp) {
  var now = nowInSecondsPrecision();
  return timestamp.isAfter(now) ? now : timestamp;
}

// This is unfortunately not there in moment.js
function scaleDuration(duration, scale) {
  return _moment2.default.duration(duration.asMilliseconds() * scale);
}